classification
Title: README file installed into site-packages conflicts with package named "readme"
Type: Stage: resolved
Components: macOS Versions: Python 3.6
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: brett.cannon, dstufft, ned.deily, python-dev, rbcollins, ronaldoussoren, scls
Priority: normal Keywords: patch

Created on 2015-07-14 08:07 by scls, last changed 2015-10-23 20:24 by python-dev. This issue is now closed.

Files
File name Uploaded Description Edit
issue24633.patch rbcollins, 2015-07-14 10:17 Rename to README.txt review
Messages (10)
msg246721 - (view) Author: Sébastien Celles (scls) Date: 2015-07-14 08:07
Hello,

the package name "readme" conflicts with Python installed site-packages/README file on case-insensitive filesystems (Mac OS X).

https://github.com/pypa/readme/issues/26
https://github.com/mgedmin/restview/issues/30
https://groups.google.com/a/continuum.io/forum/#!topic/anaconda/AGHXzB1sN0I

I wonder if README file should be be renamed README.rst or README.txt or README.md to avoid this issue or if readme package should be renamed.

Kind regards
msg246723 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2015-07-14 08:37
I agree with IIan's comments you cited in https://groups.google.com/a/continuum.io/forum/#!topic/anaconda/AGHXzB1sN0I.  Python has been installing the README file in site-packages for a very long time and there have been case-insensitive file systems for a very long time, including, but not limited to, the default case-insensitive variant of HFS on OS X.  So this seems to be an issue for the readme package, not for Python.  Even if the Python-installed README file were installed under a different name in future release, it wouldn't solve the problem for trying to install the readme package under current and past Python releases. CC-ing Donald, as the author of readme, for his comments.
msg246725 - (view) Author: Robert Collins (rbcollins) * (Python committer) Date: 2015-07-14 10:12
So, README is a valid package name. readme conflicting with README on case insensitive filesystems is a special case, but the general problem remains.

We've no particular reason to use README rather than e.g. README.txt, which would open with a much more reasonable program on Windows, and would also remove this problem.
msg246729 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2015-07-14 13:24
I agree with Robert: renaming the file to README.txt would be a good idea regardless to enable easily opening the file with a GUI editor and as a bonus removes any change of conflict with a package name.

The patch looks good to me.
msg246731 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2015-07-14 15:33
I'm +0 on the name change but, again, it wouldn't solve the conflict problem for potential users of the readme package until 3.6.
msg246732 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2015-07-14 15:37
(And such a change would only be appropriate in a feature release, as it would complicate things for existing release installers and downstream distributions, etc.)
msg246733 - (view) Author: Brett Cannon (brett.cannon) * (Python committer) Date: 2015-07-14 16:45
+1 on the file renaming. There really shouldn't be any files we put into site-packages that don't have a dot or some other symbol that we would never support as a file name for importing.
msg249029 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2015-08-23 23:47
New changeset d90a65014c42 by Robert Collins in branch 'default':
Issue #24633: site-packages/README -> README.txt.
https://hg.python.org/cpython/rev/d90a65014c42
msg249031 - (view) Author: Robert Collins (rbcollins) * (Python committer) Date: 2015-08-23 23:50
Applied to 3.6 only (since I don't want to disrupt the 3.5 release train, and think that making packagers adjust on a point release would be mean).
msg253392 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2015-10-23 20:24
New changeset 742aefb5ca46 by Steve Dower in branch 'default':
Issue #24633: Removes automatic rename of site-packages/README since README.txt is now committed.
https://hg.python.org/cpython/rev/742aefb5ca46
History
Date User Action Args
2015-10-23 20:24:22python-devsetmessages: + msg253392
2015-08-23 23:50:03rbcollinssetstatus: open -> closed
resolution: fixed
messages: + msg249031

stage: patch review -> resolved
2015-08-23 23:47:16python-devsetnosy: + python-dev
messages: + msg249029
2015-07-14 16:45:40brett.cannonsetnosy: + brett.cannon
messages: + msg246733
2015-07-14 16:38:04brett.cannonsettitle: Not a directory: '//anaconda/lib/python2.7/site-packages/readme/__about__.py' -> README file installed into site-packages conflicts with package named "readme"
2015-07-14 15:37:07ned.deilysetstage: patch review
messages: + msg246732
versions: - Python 3.4, Python 3.5
2015-07-14 15:33:09ned.deilysetmessages: + msg246731
2015-07-14 13:24:53ronaldoussorensetmessages: + msg246729
2015-07-14 10:17:25rbcollinssetfiles: + issue24633.patch
keywords: + patch
2015-07-14 10:12:53rbcollinssetnosy: + rbcollins

messages: + msg246725
versions: + Python 3.5, Python 3.6
2015-07-14 08:37:26ned.deilysetnosy: + dstufft
messages: + msg246723
2015-07-14 08:07:26sclscreate